/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.148
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.21 2009/02/14 22:25:10 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.148 2013/07/27 23:47:20 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in 12case ${EAPI} in
19 4.?.?_rc*) 13 4|5) : ;;
20 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
21 MY_PV="${PV/_rc/-rc}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
22 ;; 37 ;;
23 *) 38 release)
24 SRCTYPE="${SRCTYPE:-opensource-src}" 39 SRC_URI="http://download.qt-project.org/official_releases/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
25 MY_PV="${PV}"
26 ;; 40 ;;
27esac 41esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 42
43IUSE="aqua debug pch"
44[[ ${CATEGORY}/${PN} != dev-qt/qtwebkit ]] && IUSE+=" c++0x"
45[[ ${CATEGORY}/${PN} != dev-qt/qtxmlpatterns ]] && IUSE+=" +exceptions"
46
47DEPEND="virtual/pkgconfig"
48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
50fi
51
29S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
30 53
31HOMEPAGE="http://www.qtsoftware.com/" 54# @FUNCTION: qt4-build_pkg_setup
32SRC_URI="ftp://ftp.trolltech.com/qt/source/${MY_P}.tar.bz2" 55# @DESCRIPTION:
33 56# Sets up PATH and LD_LIBRARY_PATH.
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
40 # EAPI=2 ebuilds set use-deps, others need this: 58 # Protect users by not allowing downgrades between releases.
41 if [[ $EAPI != 2 ]]; then 59 # Downgrading revisions within the same release should be allowed.
42 # Make sure debug setting corresponds with qt-core (bug 258512) 60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
43 if [[ $PN != "qt-core" ]]; then 61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
44 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 62 eerror " *** Sanity check to keep you from breaking your system ***"
45 ~x11-libs/qt-core-${PV} debug" 63 eerror "Downgrading Qt is completely unsupported and will break your system!"
64 die "aborting to save your system"
65 else
66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
46 fi 67 fi
68 fi
47 69
48 # Check USE requirements 70 PATH="${S}/bin${PATH:+:}${PATH}"
49 qt4-build_check_use 71 if [[ ${CHOST} != *-darwin* ]]; then
72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
73 else
74 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
75 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
76 # platform detection. Note: needs to come before any directories to
77 # avoid extract failure.
78 [[ ${CHOST} == *-apple-darwin* ]] && \
79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
80 ${QT4_EXTRACT_DIRECTORIES}"
81 fi
82}
83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
89
90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Arguments for build_target_directories. Takes the directories in which the
94# code should be compiled. This is a space-separated list.
95
96# @FUNCTION: qt4-build_src_unpack
97# @DESCRIPTION:
98# Unpacks the sources.
99qt4-build_src_unpack() {
100 setqtenv
101
102 if ! version_is_at_least 4.1 $(gcc-version); then
103 ewarn "Using a GCC version lower than 4.1 is not supported."
104 fi
105
106 if [[ ${CATEGORY}/${PN} == dev-qt/qtwebkit ]]; then
107 eshopts_push -s extglob
108 if is-flagq '-g?(gdb)?([1-9])'; then
109 echo
110 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
111 ewarn "You may experience really long compilation times and/or increased memory usage."
112 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
113 ewarn "For more info check out https://bugs.gentoo.org/307861"
114 echo
50 fi 115 fi
116 eshopts_pop
117 fi
51 118
119 case ${QT4_BUILD_TYPE} in
120 live)
121 git-2_src_unpack
122 ;;
123 release)
124 local tarball="${MY_P}.tar.gz" target= targets=
125 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
126 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
127 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
128 do
129 targets+="${MY_P}/${target} "
130 done
131
132 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
133 tar -xzf "${DISTDIR}/${tarball}" ${targets}
134 eend $? || die "failed to unpack"
135 ;;
136 esac
137}
138
139# @ECLASS-VARIABLE: PATCHES
140# @DEFAULT_UNSET
141# @DESCRIPTION:
142# PATCHES array variable containing all various patches to be applied.
143# This variable is expected to be defined in global scope of ebuild.
144# Make sure to specify the full path. This variable is utilised in
145# src_prepare() phase.
146#
147# @CODE
148# PATCHES=( "${FILESDIR}/mypatch.patch"
149# "${FILESDIR}/patches_folder/" )
150# @CODE
151
152# @FUNCTION: qt4-build_src_prepare
153# @DESCRIPTION:
154# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
155# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
156qt4-build_src_prepare() {
157 setqtenv
158
159 if [[ ${QT4_BUILD_TYPE} == live ]]; then
160 QTDIR="." ./bin/syncqt || die "syncqt failed"
161 fi
162
163 # avoid X11 dependency in non-gui packages
164 local nolibx11_pkgs="qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
165 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
166
167 if use aqua; then
168 # provide a proper macx-g++-64
169 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
170
171 sed -e '/^CONFIG/s:app_bundle::' \
172 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
173 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
174 fi
175
176 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
177 skip_qmake_build
178 skip_project_generation
179 symlink_binaries_to_buildtree
180 fi
181
182 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
183 # qmake bus errors with -O2 or -O3 but -O1 works
184 # Bug 373061
185 replace-flags -O[23] -O1
186 fi
187
188 # Bug 178652
189 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
190 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
191 append-flags -fno-gcse
192 fi
193
194 if use_if_iuse c++0x; then
195 append-cxxflags -std=c++0x
196 fi
197
198 # Unsupported old gcc versions - hardened needs this :(
199 if [[ $(gcc-major-version) -lt 4 ]]; then
200 ewarn "Appending -fno-stack-protector to CXXFLAGS"
201 append-cxxflags -fno-stack-protector
202 # Bug 253127
203 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
204 -i mkspecs/common/g++.conf || die
205 fi
206
207 # Bug 261632
208 if use ppc64; then
209 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
210 append-flags -mminimal-toc
211 fi
212
213 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
214 sed -e "/^SYSTEM_VARIABLES=/i \
215 CC='$(tc-getCC)'\n\
216 CXX='$(tc-getCXX)'\n\
217 CFLAGS='${CFLAGS}'\n\
218 CXXFLAGS='${CXXFLAGS}'\n\
219 LDFLAGS='${LDFLAGS}'\n\
220 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
221 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
222 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
223 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
224 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
225 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
226 -i configure \
227 || die "sed SYSTEM_VARIABLES failed"
228
229 # Respect CC, CXX, LINK and *FLAGS in config.tests
230 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
231 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
232 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
233 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
234 || die "sed config.tests failed"
235
236 # Bug 172219
237 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
238
239 if [[ ${CHOST} == *-darwin* ]]; then
240 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
241 # crippled (by design) :/
242 local mac_gpp_conf=
243 if [[ -f mkspecs/common/mac-g++.conf ]]; then
244 # qt < 4.8 has mac-g++.conf
245 mac_gpp_conf="mkspecs/common/mac-g++.conf"
246 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
247 # qt >= 4.8 has g++-macx.conf
248 mac_gpp_conf="mkspecs/common/g++-macx.conf"
249 else
250 die "no known conf file for mac found"
251 fi
252 sed \
253 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
254 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
255 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
256 -e "s:-arch\s\w*::g" \
257 -i ${mac_gpp_conf} \
258 || die "sed ${mac_gpp_conf} failed"
259
260 # Fix configure's -arch settings that appear in qmake/Makefile and also
261 # fix arch handling (automagically duplicates our -arch arg and breaks
262 # pch). Additionally disable Xarch support.
263 local mac_gcc_confs="${mac_gpp_conf}"
264 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
265 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
266 fi
267 sed \
268 -e "s:-arch i386::" \
269 -e "s:-arch ppc::" \
270 -e "s:-arch x86_64::" \
271 -e "s:-arch ppc64::" \
272 -e "s:-arch \$i::" \
273 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
274 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
275 -e "s:-Xarch_x86_64::g" \
276 -e "s:-Xarch_ppc64::g" \
277 -i configure ${mac_gcc_confs} \
278 || die "sed -arch/-Xarch failed"
279
280 # On Snow Leopard don't fall back to 10.5 deployment target.
281 if [[ ${CHOST} == *-apple-darwin10 ]]; then
282 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
283 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
284 -i configure ${mac_gpp_conf} \
285 || die "sed deployment target failed"
286 fi
287 fi
288
289 # this one is needed for all systems with a separate -liconv, apart from
290 # Darwin, for which the sources already cater for -liconv
291 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
292 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
293 -i config.tests/unix/iconv/iconv.pro \
294 || die "sed iconv.pro failed"
295 fi
296
297 # we need some patches for Solaris
298 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
299 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
300 # use GCC over SunStudio
301 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
302 # do not flirt with non-Prefix stuff, we're quite possessive
303 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
304 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
305
306 # apply patches
307 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
308 epatch_user
309}
310
311# @FUNCTION: qt4-build_src_configure
312# @DESCRIPTION:
313# Default configure phase
314qt4-build_src_configure() {
315 setqtenv
316
317 local conf="
318 -prefix ${QTPREFIXDIR}
319 -bindir ${QTBINDIR}
320 -libdir ${QTLIBDIR}
321 -docdir ${QTDOCDIR}
322 -headerdir ${QTHEADERDIR}
323 -plugindir ${QTPLUGINDIR}
324 -importdir ${QTIMPORTDIR}
325 -datadir ${QTDATADIR}
326 -translationdir ${QTTRANSDIR}
327 -sysconfdir ${QTSYSCONFDIR}
328 -examplesdir ${QTEXAMPLESDIR}
329 -demosdir ${QTDEMOSDIR}
330 -opensource -confirm-license
331 -shared -fast -largefile -stl -verbose
332 -nomake examples -nomake demos"
333
334 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
335 # $(tc-arch). Therefore we convert it to supported values.
336 case "$(tc-arch)" in
337 amd64|x64-*) conf+=" -arch x86_64" ;;
338 ppc-macos) conf+=" -arch ppc" ;;
339 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
340 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
341 x86-macos) conf+=" -arch x86" ;;
342 x86|x86-*) conf+=" -arch i386" ;;
343 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
344 hppa|sh) conf+=" -arch generic" ;;
345 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
346 esac
347
348 conf+=" -platform $(qt_mkspecs_dir)"
349
350 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
351
352 # debug/release
353 if use debug; then
354 conf+=" -debug"
355 else
356 conf+=" -release"
357 fi
358 conf+=" -no-separate-debug-info"
359
360 # exceptions USE flag
361 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
362
363 # disable rpath (bug 380415), except on prefix (bug 417169)
364 use prefix || conf+=" -no-rpath"
365
366 # precompiled headers don't work on hardened, where the flag is masked
367 conf+=" $(qt_use pch)"
368
369 # -reduce-relocations
370 # This flag seems to introduce major breakage to applications,
371 # mostly to be seen as a core dump with the message "QPixmap: Must
372 # construct a QApplication before a QPaintDevice" on Solaris.
373 # -- Daniel Vergien
374 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
375
376 # this one is needed for all systems with a separate -liconv, apart from
377 # Darwin, for which the sources already cater for -liconv
378 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
379 conf+=" -liconv"
380 fi
381
382 if use_if_iuse glib; then
383 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
384 # avoid the -pthread argument
385 conf+=" ${glibflags//-pthread}"
386 unset glibflags
387 fi
388
389 if use aqua; then
390 # On (snow) leopard use the new (frameworked) cocoa code.
391 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
392 conf+=" -cocoa -framework"
393 # We need the source's headers, not the installed ones.
394 conf+=" -I${S}/include"
395 # Add hint for the framework location.
396 conf+=" -F${QTLIBDIR}"
397
398 # We are crazy and build cocoa + qt3support :-)
399 if use qt3support; then
400 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
401 -i configure || die
402 fi
403 else
404 conf+=" -no-framework"
405 fi
406 else
407 # freetype2 include dir is non-standard, thus pass it to configure
408 conf+=" $(pkg-config --cflags-only-I freetype2)"
409 fi
410
411 conf+=" ${myconf}"
412 myconf=
413
414 echo ./configure ${conf}
415 ./configure ${conf} || die "./configure failed"
416
417 prepare_directories ${QT4_TARGET_DIRECTORIES}
418}
419
420# @FUNCTION: qt4-build_src_compile
421# @DESCRIPTION:
422# Actual compile phase
423qt4-build_src_compile() {
424 setqtenv
425
426 build_directories ${QT4_TARGET_DIRECTORIES}
427}
428
429# @FUNCTION: qt4-build_src_test
430# @DESCRIPTION:
431# Runs tests only in target directories.
432qt4-build_src_test() {
433 # QtMultimedia does not have any test suite (bug #332299)
434 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
435
436 for dir in ${QT4_TARGET_DIRECTORIES}; do
437 emake -j1 check -C ${dir}
438 done
439}
440
441# @FUNCTION: fix_includes
442# @DESCRIPTION:
443# For MacOS X we need to add some symlinks when frameworks are
444# being used, to avoid complications with some more or less stupid packages.
445fix_includes() {
446 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
447 local frw dest f h rdir
448 # Some packages tend to include <Qt/...>
449 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
450
451 # Fake normal headers when frameworks are installed... eases life later
452 # on, make sure we use relative links though, as some ebuilds assume
453 # these dirs exist in src_install to add additional files
454 f=${QTHEADERDIR}
455 h=${QTLIBDIR}
456 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
457 f=${f#*/}
458 h=${h#*/}
459 done
460 rdir=${h}
461 f="../"
462 while [[ ${h} == */* ]] ; do
463 f="${f}../"
464 h=${h#*/}
465 done
466 rdir="${f}${rdir}"
467
468 for frw in "${D}${QTLIBDIR}"/*.framework; do
469 [[ -e "${frw}"/Headers ]] || continue
470 f=$(basename ${frw})
471 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
472 dosym "${rdir}"/${f}/Headers "${dest}"
473
474 # Link normal headers as well.
475 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
476 h=$(basename ${hdr})
477 dosym "../${rdir}"/${f}/Headers/${h} \
478 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
479 done
480 done
481 fi
482}
483
484# @FUNCTION: qt4-build_src_install
485# @DESCRIPTION:
486# Perform the actual installation including some library fixes.
487qt4-build_src_install() {
488 setqtenv
489
490 install_directories ${QT4_TARGET_DIRECTORIES}
491 install_qconfigs
492 fix_library_files
493 fix_includes
494
495 # remove .la files since we are building only shared libraries
496 prune_libtool_files
497}
498
499# @FUNCTION: setqtenv
500# @INTERNAL
501setqtenv() {
52 # Set up installation directories 502 # Set up installation directories
53 QTBASEDIR=/usr/$(get_libdir)/qt4
54 QTPREFIXDIR=/usr 503 QTPREFIXDIR=${EPREFIX}/usr
55 QTBINDIR=/usr/bin 504 QTBINDIR=${QTPREFIXDIR}/bin
56 QTLIBDIR=/usr/$(get_libdir)/qt4 505 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
57 QTPCDIR=/usr/$(get_libdir)/pkgconfig 506 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
58 QTDATADIR=/usr/share/qt4
59 QTDOCDIR=/usr/share/doc/qt-${PV} 507 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
60 QTHEADERDIR=/usr/include/qt4 508 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
61 QTPLUGINDIR=${QTLIBDIR}/plugins 509 QTPLUGINDIR=${QTLIBDIR}/plugins
62 QTSYSCONFDIR=/etc/qt4 510 QTIMPORTDIR=${QTLIBDIR}/imports
511 QTDATADIR=${QTPREFIXDIR}/share/qt4
63 QTTRANSDIR=${QTDATADIR}/translations 512 QTTRANSDIR=${QTDATADIR}/translations
513 QTSYSCONFDIR=${EPREFIX}/etc/qt4
64 QTEXAMPLESDIR=${QTDATADIR}/examples 514 QTEXAMPLESDIR=${QTDATADIR}/examples
65 QTDEMOSDIR=${QTDATADIR}/demos 515 QTDEMOSDIR=${QTDATADIR}/demos
516 QMAKE_LIBDIR_QT=${QTLIBDIR}
66 517
67 PLATFORM=$(qt_mkspecs_dir) 518 PLATFORM=$(qt_mkspecs_dir)
519 unset QMAKESPEC
68 520
69 PATH="${S}/bin:${PATH}" 521 export XDG_CONFIG_HOME="${T}"
70 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
71
72 if ! version_is_at_least 4.1 $(gcc-version) ; then
73 ewarn "Using a GCC version lower than 4.1 is not supported!"
74 echo
75 ebeep 5
76 fi
77
78 if use custom-cxxflags; then
79 echo
80 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
81 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
82 ewarn "recommend to unset this useflag. But you are free to experiment with it."
83 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
84 ewarn "for breakfast. ;-) "
85 echo
86 fi
87
88} 522}
89 523
90qt4-build_src_unpack() { 524# @FUNCTION: prepare_directories
91 local target targets 525# @USAGE: < directories >
92 for target in configure LICENSE.{GPL2,GPL3} projects.pro \ 526# @INTERNAL
93 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 527# @DESCRIPTION:
94 ${QT4_EXTRACT_DIRECTORIES}; do 528# Generates Makefiles for the given list of directories.
95 targets="${targets} ${MY_P}/${target}" 529prepare_directories() {
530 for x in "$@"; do
531 pushd "${S}"/${x} >/dev/null || die
532 einfo "Running qmake in: ${x}"
533 "${S}"/bin/qmake \
534 "LIBS+=-L${QTLIBDIR}" \
535 "CONFIG+=nostrip" \
536 || die "qmake failed"
537 popd >/dev/null || die
96 done 538 done
97
98 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
99 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
100
101 case "${PV}" in
102 4.4.?)
103 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
104 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
105 ;;
106 esac
107
108 # Be backwards compatible for now
109 if [[ $EAPI != 2 ]]; then
110 qt4-build_src_prepare
111 fi
112} 539}
113 540
114qt4-build_src_prepare() { 541# @FUNCTION: build_directories
115 cd "${S}" 542# @USAGE: < directories >
116 543# @INTERNAL
117 if [[ ${PN} != qt-core ]]; then 544# @DESCRIPTION:
118 skip_qmake_build_patch 545# Compiles the code in the given list of directories.
119 skip_project_generation_patch
120 symlink_binaries_to_buildtree
121 fi
122
123 # Bug 172219
124 if !use custom-cxxflags;then
125 # Don't let the user go too overboard with flags.
126 strip-flags
127 replace-flags -O3 -O2
128 fi
129
130 # Bug 253127
131 # Unsupported old gcc versions - hardened needs this :(
132 if [[ $(gcc-major-version) -lt "4" ]] ; then
133 ewarn "Appending -fno-stack-protector to CXXFLAGS"
134 append-cxxflags -fno-stack-protector
135 fi
136
137 # Bug 178652
138 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then
139 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
140 append-flags -fno-gcse
141 fi
142
143
144 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
145 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
146 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
147 -e "s:X11R6/::" \
148 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
149
150 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
151 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
152 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
153 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
154
155}
156
157qt4-build_src_configure() {
158
159 myconf="$(standard_configure_options) ${myconf}"
160
161 echo ./configure ${myconf}
162 ./configure ${myconf} || die "./configure failed"
163}
164
165qt4-build_src_compile() {
166 # Be backwards compatible for now
167 if [[ $EAPI != 2 ]]; then
168 qt4-build_src_configure
169 fi
170
171 build_directories "${QT4_TARGET_DIRECTORIES}"
172}
173
174qt4-build_src_install() {
175 install_directories "${QT4_TARGET_DIRECTORIES}"
176 install_qconfigs
177 fix_library_files
178}
179
180standard_configure_options() {
181 local myconf=""
182
183 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)"
184
185 # Disable visibility explicitly if gcc version isn't 4
186 if [[ "$(gcc-major-version)" -lt "4" ]]; then
187 myconf="${myconf} -no-reduce-exports"
188 fi
189
190 # precompiled headers doesn't work on hardened, where the flag is masked.
191 if use pch; then
192 myconf="${myconf} -pch"
193 else
194 myconf="${myconf} -no-pch"
195 fi
196
197 if use debug; then
198 myconf="${myconf} -debug -no-separate-debug-info"
199 else
200 myconf="${myconf} -release -no-separate-debug-info"
201 fi
202
203 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
204 # ${ARCH}. Therefore we convert it to supported values.
205 case "${ARCH}" in
206 amd64) myconf="${myconf} -arch x86_64" ;;
207 ppc|ppc64) myconf="${myconf} -arch powerpc" ;;
208 x86|x86-*) myconf="${myconf} -arch i386" ;;
209 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch ${ARCH}" ;;
210 hppa|sh) myconf="${myconf} -arch generic" ;;
211 *) die "${ARCH} is unsupported by this eclass. Please file a bug." ;;
212 esac
213
214 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath
215 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
216 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
217 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
218 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
219 -demosdir ${QTDEMOSDIR} -silent -fast
220 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
221 $(use x86-fbsd || echo -reduce-relocations)
222 -nomake examples -nomake demos"
223
224 echo "${myconf}"
225}
226
227build_directories() { 546build_directories() {
228 local dirs="$@"
229 for x in ${dirs}; do 547 for x in "$@"; do
230 cd "${S}"/${x} 548 pushd "${S}"/${x} >/dev/null || die
231 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 549 emake \
232 emake || die "emake failed" 550 AR="$(tc-getAR) cqs" \
551 CC="$(tc-getCC)" \
552 CXX="$(tc-getCXX)" \
553 LINK="$(tc-getCXX)" \
554 RANLIB=":" \
555 STRIP=":"
556 popd >/dev/null || die
233 done 557 done
234} 558}
235 559
560# @FUNCTION: install_directories
561# @USAGE: < directories >
562# @INTERNAL
563# @DESCRIPTION:
564# Runs emake install in the given directories, which are separated by spaces.
236install_directories() { 565install_directories() {
237 local dirs="$@"
238 for x in ${dirs}; do 566 for x in "$@"; do
239 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 567 pushd "${S}"/${x} >/dev/null || die
240 emake INSTALL_ROOT="${D}" install || die "emake install failed" 568 emake INSTALL_ROOT="${D}" install
241 popd >/dev/null || die "Can't popd from ${S}/${x}" 569 popd >/dev/null || die
242 done 570 done
243} 571}
244 572
245# @ECLASS-VARIABLE: QCONFIG_ADD 573# @ECLASS-VARIABLE: QCONFIG_ADD
246# @DESCRIPTION: 574# @DESCRIPTION:
247# List options that need to be added to QT_CONFIG in qconfig.pri 575# List options that need to be added to QT_CONFIG in qconfig.pri
248QCONFIG_ADD="${QCONFIG_ADD:-}" 576: ${QCONFIG_ADD:=}
249 577
250# @ECLASS-VARIABLE: QCONFIG_REMOVE 578# @ECLASS-VARIABLE: QCONFIG_REMOVE
251# @DESCRIPTION: 579# @DESCRIPTION:
252# List options that need to be removed from QT_CONFIG in qconfig.pri 580# List options that need to be removed from QT_CONFIG in qconfig.pri
253QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 581: ${QCONFIG_REMOVE:=}
254 582
255# @ECLASS-VARIABLE: QCONFIG_DEFINE 583# @ECLASS-VARIABLE: QCONFIG_DEFINE
256# @DESCRIPTION: 584# @DESCRIPTION:
257# List variables that should be defined at the top of QtCore/qconfig.h 585# List variables that should be defined at the top of QtCore/qconfig.h
258QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 586: ${QCONFIG_DEFINE:=}
259 587
588# @FUNCTION: install_qconfigs
589# @INTERNAL
590# @DESCRIPTION:
591# Install gentoo-specific mkspecs configurations.
260install_qconfigs() { 592install_qconfigs() {
261 local x 593 local x
262 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 594 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
263 for x in QCONFIG_ADD QCONFIG_REMOVE; do 595 for x in QCONFIG_ADD QCONFIG_REMOVE; do
264 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 596 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
265 done 597 done
266 insinto ${QTDATADIR}/mkspecs/gentoo 598 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
267 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 599 doins "${T}"/${PN}-qconfig.pri
268 fi 600 fi
269 601
270 if [[ -n ${QCONFIG_DEFINE} ]]; then 602 if [[ -n ${QCONFIG_DEFINE} ]]; then
271 for x in ${QCONFIG_DEFINE}; do 603 for x in ${QCONFIG_DEFINE}; do
272 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 604 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
273 done 605 done
274 insinto ${QTHEADERDIR}/Gentoo 606 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
275 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 607 doins "${T}"/gentoo-${PN}-qconfig.h
276 fi 608 fi
277} 609}
278 610
611# @FUNCTION: generate_qconfigs
612# @INTERNAL
613# @DESCRIPTION:
614# Generates gentoo-specific qconfig.{h,pri}.
279generate_qconfigs() { 615generate_qconfigs() {
280 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 616 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
281 local x qconfig_add qconfig_remove qconfig_new 617 local x qconfig_add qconfig_remove qconfig_new
282 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 618 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
283 [[ -f ${x} ]] || continue 619 [[ -f ${x} ]] || continue
284 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 620 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
285 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 621 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
286 done 622 done
287 623
288 # these error checks do not use die because dying in pkg_post{inst,rm} 624 # these error checks do not use die because dying in pkg_post{inst,rm}
289 # just makes things worse. 625 # just makes things worse.
290 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 626 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
291 # start with the qconfig.pri that qt-core installed 627 # start with the qconfig.pri that qtcore installed
292 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 628 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
293 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 629 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
294 eerror "cp qconfig failed." 630 eerror "cp qconfig failed."
295 return 1 631 return 1
296 fi 632 fi
297 633
298 # generate list of QT_CONFIG entries from the existing list 634 # generate list of QT_CONFIG entries from the existing list
299 # including qconfig_add and excluding qconfig_remove 635 # including qconfig_add and excluding qconfig_remove
300 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 636 for x in $(sed -n 's/^QT_CONFIG +=//p' \
301 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 637 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
302 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 638 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
303 done 639 done
304 640
305 # replace the existing QT_CONFIG list with qconfig_new 641 # replace the existing QT_CONFIG list with qconfig_new
306 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 642 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
307 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 643 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
330 "${ROOT}${QTHEADERDIR}" 2>/dev/null 666 "${ROOT}${QTHEADERDIR}" 2>/dev/null
331 fi 667 fi
332 fi 668 fi
333} 669}
334 670
671# @FUNCTION: qt4-build_pkg_postrm
672# @DESCRIPTION:
673# Regenerate configuration when the package is completely removed.
335qt4-build_pkg_postrm() { 674qt4-build_pkg_postrm() {
336 generate_qconfigs 675 generate_qconfigs
337} 676}
338 677
678# @FUNCTION: qt4-build_pkg_postinst
679# @DESCRIPTION:
680# Regenerate configuration, plus throw a message about possible
681# breakages and proposed solutions.
339qt4-build_pkg_postinst() { 682qt4-build_pkg_postinst() {
340 generate_qconfigs 683 generate_qconfigs
341 echo
342 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
343 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
344 ewarn "should recompile the packages providing these plugins. Also, make sure you"
345 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
346 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
347 ewarn
348 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
349 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
350 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
351 ewarn "configuration."
352 ewarn
353 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
354 echo
355} 684}
356 685
686# @FUNCTION: skip_qmake_build
687# @INTERNAL
688# @DESCRIPTION:
689# Patches configure to skip qmake compilation, as it's already installed by qtcore.
357skip_qmake_build_patch() { 690skip_qmake_build() {
358 # Don't need to build qmake, as it's already installed from qt-core
359 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 691 sed -i -e "s:if true:if false:g" "${S}"/configure || die
360} 692}
361 693
362skip_project_generation_patch() { 694# @FUNCTION: skip_project_generation
695# @INTERNAL
696# @DESCRIPTION:
363 # Exit the script early by throwing in an exit before all of the .pro files are scanned 697# Exit the script early by throwing in an exit before all of the .pro files are scanned.
698skip_project_generation() {
364 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 699 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
365 -i "${S}"/configure || die "Sed failed"
366} 700}
367 701
702# @FUNCTION: symlink_binaries_to_buildtree
703# @INTERNAL
704# @DESCRIPTION:
705# Symlinks generated binaries to buildtree, so they can be used during compilation time.
368symlink_binaries_to_buildtree() { 706symlink_binaries_to_buildtree() {
369 for bin in qmake moc uic rcc; do 707 for bin in qmake moc uic rcc; do
370 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 708 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
371 done 709 done
372} 710}
373 711
712# @FUNCTION: fix_library_files
713# @INTERNAL
714# @DESCRIPTION:
715# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
716# moves the *.pc files into the pkgconfig directory.
374fix_library_files() { 717fix_library_files() {
718 local libfile
375 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 719 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
376 if [[ -e ${libfile} ]]; then 720 if [[ -e ${libfile} ]]; then
377 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 721 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
378 fi 722 fi
379 done 723 done
380 724
381 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 725 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
382 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 726 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
383 if [[ -e ${libfile} ]]; then 727 if [[ -e ${libfile} ]]; then
384 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 728 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
385 729
386 # Move .pc files into the pkgconfig directory 730 # Move .pc files into the pkgconfig directory
387
388 dodir ${QTPCDIR} 731 dodir ${QTPCDIR#${EPREFIX}}
389 mv ${libfile} "${D}"/${QTPCDIR}/ \ 732 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
390 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
391 fi 733 fi
392 done 734 done
393 735
394 # Don't install an empty directory 736 # Don't install an empty directory
395 rmdir "${D}"/${QTLIBDIR}/pkgconfig 737 rmdir "${D}"/${QTLIBDIR}/pkgconfig
396} 738}
397 739
740# @FUNCTION: qt_use
741# @USAGE: < flag > [ feature ] [ enableval ]
742# @DESCRIPTION:
743# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
744# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
745# will be used for that. If [enableval] is not specified, it omits the
746# "-${enableval}" part.
398qt_use() { 747qt_use() {
399 local flag="${1}" 748 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
400 local feature="${1}"
401 local enableval=
402
403 [[ -n ${2} ]] && feature=${2}
404 [[ -n ${3} ]] && enableval="-${3}"
405
406 if use ${flag}; then
407 echo "${enableval}-${feature}"
408 else
409 echo "-no-${feature}"
410 fi
411} 749}
412 750
413# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 751# @FUNCTION: qt_mkspecs_dir
752# @RETURN: the specs-directory w/o path
414# @DESCRIPTION: 753# @DESCRIPTION:
415# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 754# Allows us to define which mkspecs dir we want to use.
416# (eutils.eclass), line per line.
417#
418# Example:
419# @CODE
420# pkg_setup() {
421# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
422# ~x11-libs/qt-gui-${PV} qt3support"
423# qt4-build_check_use
424# }
425# @CODE
426
427# Run built_with_use on each flag and print appropriate error messages if any
428# flags are missing
429_qt_built_with_use() {
430 local missing opt pkg flag flags
431
432 if [[ ${1} = "--missing" ]]; then
433 missing="${1} ${2}" && shift 2
434 fi
435 if [[ ${1:0:1} = "-" ]]; then
436 opt=${1} && shift
437 fi
438
439 pkg=${1} && shift
440
441 for flag in "${@}"; do
442 flags="${flags} ${flag}"
443 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
444 flags="${flags}*"
445 else
446 [[ ${opt} = "-o" ]] && return 0
447 fi
448 done
449 if [[ "${flags# }" = "${@}" ]]; then
450 return 0
451 fi
452 if [[ ${opt} = "-o" ]]; then
453 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
454 else
455 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
456 fi
457 return 1
458}
459
460# @FUNCTION: qt4-build_check_use
461# @DESCRIPTION:
462# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
463# USE flags listed.
464#
465# If any of the required USE flags are missing, an eerror will be printed for
466# each package with missing USE flags.
467qt4-build_check_use() {
468 local line missing
469 while read line; do
470 [[ -z ${line} ]] && continue
471 if ! _qt_built_with_use ${line}; then
472 missing=true
473 fi
474 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
475 if [[ -n ${missing} ]]; then
476 echo
477 eerror "Flags marked with an * are missing."
478 die "Missing USE flags found"
479 fi
480}
481
482qt_mkspecs_dir() { 755qt_mkspecs_dir() {
483 # Allows us to define which mkspecs dir we want to use.
484 local spec 756 local spec=
485 757
486 case ${CHOST} in 758 case "${CHOST}" in
487 *-freebsd*|*-dragonfly*) 759 *-freebsd*|*-dragonfly*)
488 spec="freebsd" ;; 760 spec=freebsd ;;
489 *-openbsd*) 761 *-openbsd*)
490 spec="openbsd" ;; 762 spec=openbsd ;;
491 *-netbsd*) 763 *-netbsd*)
492 spec="netbsd" ;; 764 spec=netbsd ;;
493 *-darwin*) 765 *-darwin*)
766 if use aqua; then
767 # mac with carbon/cocoa
768 spec=macx
769 else
770 # darwin/mac with x11
494 spec="darwin" ;; 771 spec=darwin
772 fi
773 ;;
774 *-solaris*)
775 spec=solaris ;;
495 *-linux-*|*-linux) 776 *-linux-*|*-linux)
496 spec="linux" ;; 777 spec=linux ;;
497 *) 778 *)
498 die "Unknown CHOST, no platform choosen." 779 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
499 esac 780 esac
500 781
501 CXX=$(tc-getCXX) 782 case "$(tc-getCXX)" in
502 if [[ ${CXX/g++/} != ${CXX} ]]; then 783 *g++*)
503 spec="${spec}-g++" 784 spec+=-g++ ;;
504 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 785 *icpc*)
505 spec="${spec}-icc" 786 spec+=-icc ;;
506 else 787 *)
507 die "Unknown compiler ${CXX}." 788 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
789 esac
790
791 # Add -64 for 64bit profiles
792 if use x64-freebsd ||
793 use amd64-linux ||
794 use x64-macos ||
795 use x64-solaris ||
796 use sparc64-solaris
797 then
798 spec+=-64
508 fi 799 fi
509 800
510 echo "${spec}" 801 echo "${spec}"
511} 802}
512 803
513case ${EAPI:-0} in 804# @FUNCTION: qt_nolibx11
514 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 805# @INTERNAL
806# @DESCRIPTION:
807# Skip X11 tests for packages that don't need X libraries installed.
808qt_nolibx11() {
809 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
810}
811
515 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 812EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
516esac

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.148

  ViewVC Help
Powered by ViewVC 1.1.20